// @flow
/**
 * Copyright (c) 2017-present, Evosphere.
 * All rights reserved.
 */

import containerMixin from './containerMixin';
import type { ServiceType, ParameterType, ServiceContainerType } from "./containerMixin";

export type KernelType = {
  set: (name : string, service : ServiceType) => KernelType,
  setParameter: (name : string, service : mixed) => KernelType,
  get: (name: string) => ServiceType | ParameterType,
  getServices: () => ServiceContainerType,
  loadServices: (services : ?ServiceContainerType) => void,
  loadParameters: (parameters : {[key: string] : mixed }) => void,
};

export default function Kernel () {}
containerMixin(Kernel);

