// @flow
/**
 * Copyright (c) 2017-present, Evosphere.
 * All rights reserved.
 */
import type { KernelType } from "./core/Kernel";

export type KernelFactoryConfigurationType = {
  getEnvironment: () => string,
  registerServices?: (register : (name : string, service : Object) => void, parameters: Object, environment : string) => void,
  getParameters: (environment : string) => Object,
};

export type TaskType = {
  registerServices?: (register : (name : string, service : Object) => void, parameters: Object, environment : string) => void,

  /**
   * Called when the kernel is getting configured
   */
  configureKernel? : (config : KernelFactoryConfigurationType, kernel : Object) => void,
};

export type KernelFactoryType = {
  create: (config: KernelFactoryConfigurationType) => Promise<KernelType>,
  getTasks: () => Array<TaskType>,
  clearTaskRegistry: () => void,
  registerTasks: (tasks : Array<TaskType>) => void,
  executeTasks: (name : string, args : Array<mixed>) => void,
  executeTasksAndReturnValue: (name : string, args : Array<mixed>) => void,
}